//+------------------------------------------------------------------+ 
//|   TRO_Account_Info                                               | 
//|                                                                  | 
//|   Copyright  2008, AVERY T. HORTON, JR. AKA TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
 

#property indicator_chart_window



string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 


double point;


      
//+------------------------------------------------------------------+

int init()
  {
   period = Period() ;   
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    = "info"+symbol+period ;

   


   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
    Comment("");
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{


  
 Comment("" 
         + "\n" 
         + "------------------------------------------------" 
         + "\n" 
         + "BROKER INFORMATION:" 
         + "\n" 
         + "Broker Company:      " + AccountCompany() 
         + "\n" 
         + "------------------------------------------------" 
         + "\n" 
         + "ACCOUNT INFORMATION:" 
         + "\n" 
         + "Account Name:          " + AccountName() 
         + "\n" 
         + "Account Number:       " + AccountNumber() 
         + "\n" 
         + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0) 
         + "\n" 
         + "Account Balance:       " + DoubleToStr(AccountBalance(), 2) 
         + "\n" 
         + "Account Currency:     " + AccountCurrency() 
         + "\n" 
         + "Account Equity:         " + DoubleToStr(AccountEquity(), 2) 
         + "\n" 
         + "------------------------------------------------" 
         + "\n" 
         + "MARGIN INFORMATION:" 
         + "\n" 
         + "Free Margin:              " + DoubleToStr(AccountFreeMargin(), 2) 
         + "\n" 
         + "Used Margin:              " + DoubleToStr(AccountMargin(), 2) 
         + "\n" 
         + "------------------------------------------------" 
         + "\n" 
         + "Actual Server Time     " + TimeToStr(TimeCurrent(), TIME_SECONDS) 
         + "\n" 
      + "------------------------------------------------");
   return(0);
  }

  
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
/*

*/